local EquipmentPanel = {
    onClick = nil,

    equipTitle = nil,
    equipGrid = nil,
    highlighting = nil,

    create = function(self, equipItems, highlighting)
        self.highlighting = highlighting
        self.equipTitle = osrs.Ui:textbox({text = "Equipment",})
        self.equipGrid = osrs.Ui:grid(
            { 
                columns=3,
                height = 300,
                width = 200,
                sizeMode = 1,
                border = false,
            }
        )
        self:setupEquip(equipItems)
    end,

    setupEquip = function(self, equipItems)
        for index, item in pairs(equipItems) do
            if item.id ~= -1 then
                icon = osrs.Ui:imageButton(
                    {
                    tooltip = string.format("Name: %s, Quantity: %s%s", 
                    item.name, tostring(item.quantity), item:getStackDiffrence()),
                    sizeMode = 1,
                    width = 40,
                    height = 40,
                    onClick = function()
                        self.onClick(item, index, 2)
                    end
                }
            )
            icon:setObjId(item.id)
            else
                icon = osrs.Ui:textButton({text = "", sizeMode = 1, tooltip = "Empty Slot", width = 48, height = 46, onClick = function() self.onClick(item, index, 2) end})
            end
            if item.highlited and self.highlighting then 
                icon.style.colour.button = osrs.Colour4.new(0.0, 1.0, 0.0, 1.0)
            end
            -- spaces for head or legs
            if index == 1 or index == 8 then 
                self.equipGrid:addChild(osrs.Ui:dummy({sizeMode = 1, width = 40, height = 40}))
                self.equipGrid:addChild(icon)
                self.equipGrid:addChild(osrs.Ui:dummy({sizeMode = 1, width = 40, height = 40}))
            else
                self.equipGrid:addChild(icon)
            end
        end
    end,

    show = function(self, panel)
        panel:addChild(self.equipTitle)
        panel:addChild(self.equipGrid)
    end,

    clear = function(self, panel)
        panel:removeChild(self.equipTitle)
        panel:removeChild(self.equipGrid)
    end,    
    
}

return EquipmentPanel