local InventoryPanel = {
    onClick = nil,

    invTitle = nil,
    itemGrid = nil,
    highlighting = nil,

    create = function(self, invItems, highlighting)
        self.highlighting = highlighting
        self.invTitle = osrs.Ui:textbox({text = "Inventory",})
        self.itemGrid = osrs.Ui:grid(
            { 
                columns=4,
                height = 400,
                width = 200,
                sizeMode = 1,
                border = false,
            }
        )
        self:setupInv(invItems)
    end,

    setupInv = function(self, invItems)
        for index, item in pairs(invItems) do 
            if item.id ~= -1 then
                icon = osrs.Ui:imageButton(
                    {                  
                        tooltip = string.format("Name: %s, Quantity: %s%s", 
                        item.name, tostring(item.quantity), item:getStackDiffrence()),
                        sizeMode = 1,
                        width = 40,
                        height = 40,
                        onClick = function()
                            self.onClick(item, index, 1)
                        end
                    }
                )
                icon:setObjId(item.id)
            else
                icon = osrs.Ui:textButton({text = "", sizeMode = 1, tooltip = "Empty Slot", width = 48, height = 46, onClick = function() self.onClick(item, index, 1) end})
            end
            if item.highlited and self.highlighting then 
                icon.style.colour.button = osrs.Colour4.new(0.0, 1.0, 0.0, 1.0)
            end
            self.itemGrid:addChild(icon)
        end
    end,

    show = function(self, panel)
        panel:addChild(self.invTitle)
        panel:addChild(self.itemGrid)
    end,

    clear = function(self, panel)
        panel:removeChild(self.invTitle)
        panel:removeChild(self.itemGrid)
    end,
}

return InventoryPanel