local RunePanel = {
    onClick = nil,

    runeTitle = nil,
    runeGrid = nil,
    highlighting = nil,

    create = function(self, runeItems, highlighting)
        self.highlighting = highlighting
        self.runeTitle = osrs.Ui:textbox({text = "Rune Pouch",})
        self.runeGrid = osrs.Ui:grid(
            { 
                columns=3,
                height = 50,
                width = 200,
                sizeMode = 1,
                border = false,
            }
        )
        self:setupRunes(runeItems)
    end,

    setupRunes = function(self, runeItems)
        for index, item in pairs(runeItems) do 
            if item.id ~= -1 then
                icon = osrs.Ui:imageButton(
                    {                  
                        tooltip = string.format("Name: %s, Quantity: %s%s", 
                        item.name, tostring(item.quantity), item:getStackDiffrence()),
                        sizeMode = 1,
                        width = 40,
                        height = 40,
                        onClick = function()
                            self.onClick(item, index, 3)
                        end
                    }
                )
                icon:setObjId(item.id)
            else
                icon = osrs.Ui:textButton({text = "", sizeMode = 1, tooltip = "Empty Slot", width = 48, height = 46, onClick = function() self.onClick(item, index, 3) end})
            end
            if item.highlited and self.highlighting then 
                icon.style.colour.button = osrs.Colour4.new(0.0, 1.0, 0.0, 1.0)
            end
            self.runeGrid:addChild(icon)
        end
    end,

    show = function(self, panel)
        panel:addChild(self.runeTitle)
        panel:addChild(self.runeGrid)
    end,

    clear = function(self, panel)
        panel:removeChild(self.runeTitle)
        panel:removeChild(self.runeGrid)
    end,    
}

return RunePanel