local SpellbookPanel = {
    onSwap = nil,

    popupMenu = nil,
    spellbookTitle = nil,
    spellbookIcon = nil,

    create = function(self, spellbook, highlighting)
        self.spellbookTitle = osrs.Ui:textbox({text = "Spellbook",})
        if spellbook.id == -1 then 
            self.spellbookIcon = osrs.Ui:textButton({text = "", sizeMode = 1, tooltip = "Empty Slot", width = 48, height = 38, onClick = function() self:onClick() end})
        else
            self.spellbookIcon = osrs.Ui:imageButton(
                {
                    sizeMode = 1,
                    width = 40,
                    height = 40,
                    tooltip = string.format("Name: %s", spellbook.name),
                    onClick = function()
                        self:onClick()
                    end
                }
            )
            self.spellbookIcon:setSpriteId(spellbook.id)
        end
        if spellbook.highlited and highlighting then
            self.spellbookIcon.style.colour.button = osrs.Colour4.new(0.0, 1.0, 0.0, 1.0)
        end
    end,

    onClick = function(self, popupMenu)
        standardButton = osrs.Ui:textButton(
            {
                text = "Update Slot to Standard",
                onClick = function()
                    self.popupMenu:closeWindow()
                    self.onSwap(1)
                end
            }
        )
        ancientButton = osrs.Ui:textButton(
            {
                text = "Update Slot to Ancient",
                onClick = function()
                    self.popupMenu:closeWindow()
                    self.onSwap(2)
                end
            }
        )
        lunarButton = osrs.Ui:textButton(
            {
                text = "Update Slot to Lunar",
                onClick = function()
                    self.popupMenu:closeWindow()
                    self.onSwap(3)
                end
            }
        )
        arceuusButton = osrs.Ui:textButton(
            {
                text = "Update Slot to Arceuus",
                onClick = function()
                    self.popupMenu:closeWindow()
                    self.onSwap(4)
                end
            }
        )
        noneButton = osrs.Ui:textButton(
            {
                text = "Update Slot to None",
                onClick = function()
                    self.popupMenu:closeWindow()
                    self.onSwap(5)
                end
            }
        )
        self.popupMenu:showWindow({standardButton, ancientButton, lunarButton, arceuusButton, noneButton})
    end,

    show = function(self, panel)
        panel:addChild(self.spellbookTitle)
        panel:addChild(self.spellbookIcon)
    end,

    clear = function(self, panel)
        panel:removeChild(self.spellbookTitle)
        panel:removeChild(self.spellbookIcon)
    end,    
}

return SpellbookPanel