ThemeTable = require("UI/themes")
local json = require("json")

local ThemeTool = {
    themeKey = "key20002",
    themeTable = nil,
    currentTheme = nil,

    initialize = function(self)
        self.themeTable = ThemeTable
        osrs.Persistence:getValue(self.themeKey,
        function(_, callbackValue)
            if(callbackValue == nil) then
                self.currentTheme = self.themeTable[1].name
                return
            end
            self.currentTheme = json.decode(callbackValue)
        end)
    end,

    getThemes = function(self)
        return self.themeTable
    end,

    setTheme = function(self, newTheme)
        self.currentTheme = newTheme
    end,

    update = function(self, window)
        for i, t in pairs(self.themeTable) do
            if t.name == self.currentTheme then
                if t.colourArray.colourText ~= nil then 
                    window.style.colour.text = t.colourArray.colourText
                end
                if t.colourArray.colourButton ~= nil then 
                    window.style.colour.button = t.colourArray.colourButton
                end 
                if t.colourArray.colourCheckMark ~= nil then 
                    window.style.colour.checkMark = t.colourArray.colourCheckMark
                end
                if t.colourArray.colourButtonHovered ~= nil then 
                    window.style.colour.buttonHovered = t.colourArray.colourButtonHovered
                end 
                if t.colourArray.colourFrameBackgroundHovered ~= nil then 
                    window.style.colour.frameBackgroundHovered = t.colourArray.colourFrameBackgroundHovered
                end
                if t.colourArray.colourFrameBackground ~= nil then 
                    window.style.colour.frameBackground = t.colourArray.colourFrameBackground
                end
                if t.colourArray.colourTitleBackgroundActive ~= nil then 
                    window.style.colour.titleBackgroundActive = t.colourArray.colourTitleBackgroundActive
                end
                if t.colourArray.colourWindowBackground ~= nil then 
                    window.style.colour.windowBackground = t.colourArray.colourWindowBackground
                end
                if t.colourArray.colourHeader ~= nil then
                    window.style.colour.header = t.colourArray.colourHeader
                end
            end
        end
    end,

    onClose = function(self)
        osrs.Persistence:setValue(self.themeKey, json.encode(self.currentTheme),
        function(key, success)
            if(success) then
                osrs.print("Theme Saved.") 
            else
                osrs.print("Theme failed.")
            end
        end)
    end
}

return ThemeTool