Item = {
    id = nil, 
    name = "nil", 
    quantity = nil,
    highlited = nil,
    stackDiffrence = nil,
    stackTypes = {},
}

function Item:new(o, item, quantity)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
    if item ~= nil or item ~= -1 then
        o.id = item
        o.name = string.format(osrs.ClientOp.oc_name(item))
        o.quantity = quantity
        o.highlited = false
        o.stackDiffrence = nil
        o.stackTypes = {
            [1] = function(item1) return item1.quantity == o.quantity end,
            [2] = function(item1) return item1.quantity >= o.quantity end,
            [3] = function(item1) return item1.quantity <= o.quantity end,
        }
    end
    return o
end

function Item:remake(o, item)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
    o.id = item["id"]
    o.name = string.format(osrs.ClientOp.oc_name(o.id))
    if item["quantity"] == nil then
        o.quantity = 1
    else
        o.quantity = item["quantity"]
    end
    o.highlited = false
    o.stackDiffrence = item["stackDiffrence"]
    o.stackTypes = {
        [1] = function(item1) return item1.quantity == o.quantity end,
        [2] = function(item1) return item1.quantity >= o.quantity end,
        [3] = function(item1) return item1.quantity <= o.quantity end,
    }
    return o
end

function Item:copy(o, item)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
    o.id = item.id
    o.name = item.name
    o.quantity = item.quantity
    o.highlited = item.highlited
    o.stackDiffrence = item.stackDiffrence
    o.stackTypes = item.stackTypes
    return o
end

function Item:getItem()
    item = {}
    item["id"] = self.id
    if self.quantity > 1 then
        item["quantity"] = self.quantity
    end
    item["stackDiffrence"] = self.stackDiffrence
    return item
end

function Item:getStackDiffrence()
    if self.stackDiffrence == 1 then
        return ", Stack Diffrece: !="
    elseif self.stackDiffrence == 2 then 
        return ", Stack Diffrece: <"
    elseif self.stackDiffrence == 3 then
        return ", Stack Diffrece: >"
    else
        return ""
    end
end

function Item:printName()
    osrs.print(self.name)
end